<%@ PAGE LANGUAGE="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.IO" %>
<html>
<head>
<script runat="server">
void Page_Load(object sender, EventArgs e) {
	if (!IsPostBack) {
		datagrid1.DataSource = CreateDataSource();
		datagrid1.DataBind();
	}
}

ICollection CreateDataSource() {
	DirectoryInfo di = new DirectoryInfo(Server.MapPath("."));
	FileInfo[] fi = di.GetFiles();

	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("fileid", typeof(int)));
	dt.Columns.Add(new DataColumn("filename", typeof(String)));
	dt.Columns.Add(new DataColumn("filesize", typeof(long)));
	dt.Columns.Add(new DataColumn("date", typeof(DateTime)));

	for (int i = 0; i < fi.Length; i++) {
		dr = dt.NewRow();
		dr[0] = i;
		dr[1] = fi[i].Name;
		dr[2] = fi[i].Length;
		dr[3] = fi[i].LastWriteTime;
		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);

	return dv;
}

void datagrid1_Sort(object sender, DataGridSortCommandEventArgs e) {
	DataView dv = (DataView) CreateDataSource();
	dv.Sort = e.SortExpression;
	datagrid1.DataSource = dv;
	datagrid1.DataBind();
}
</script>
</head>
<body>
<form runat="server">
	<div align="center">
	<asp:DataGrid id="datagrid1"
		AllowSorting="true"
		OnSortCommand="datagrid1_Sort"
		AutoGenerateColumns="false"
		runat="server">
		<Columns>
		<asp:BoundColumn HeaderText="t@C" DataField="filename" SortExpression="filename" />
		<asp:BoundColumn HeaderText="TCY" DataField="filesize" SortExpression="filesize" />
		<asp:BoundColumn HeaderText="XV" DataField="date" SortExpression="date" />
		</Columns>
	</asp:DataGrid>
	<asp:Label id="Message" runat="server" />
	</div>
</form>
</body>
</html>
